; File Name   :	kompaktor-kasette\BOLERO.rom
; Format      :	Binary file
; Base Address:	0000h Range: 0300h - 0980h Loaded length: 0680h

; Autor: Dr. R. Wobst
; Bandtestprogramm BOLERO
; 
; Mit diesem Programm knnen Sie berprfen, welche Aufzeichnungs-
; geschwindigkeit von QUICKSAVE Ihr Bandgert zult. Auch wenn
; Sie QUICKSAVE nicht benutzen, knnen Sie damit Ihr Bandgert und
; auch Ihre Kassetten prfen.


		cpu	z80

		org 300h
		jp	TT
; ---------------------------------------------------------------------------
		db "TT      ",0
		db    0

; ---------------------------------------------------------------------------
TT:		ld	hl, RST8	; Ausgabe Zeichenkette
		ld	(9), hl
		ld	a, 0C3h		; JP
		ld	(8), a
		call	CLS
		rst	8
		db "-- Bandtestprogramm fuer Quicksave --",0Dh,0Ah
		db 0Ah
		db "R.Wobst 1987",0Dh,0Ah
		db 0Ah
		db 0Ah
		db "Schalten Sie das Bandgeraet mit der",0Dh,0Ah
		db "zu testenden Kassette auf Aufnahme.",0Dh,0Ah
		db "Lassen Sie das Band laufen und druecken",0Dh,0Ah
		db "Sie dann auf ENTER.",0Dh,0Ah
		db "Das Programm zeichnet mit wachsender",0Dh,0Ah
		db "Geschwindigkeit auf, und zwar 20",0Dh,0Ah
		db "Bloecke jeder Geschwindigkeit.",0Dh,0Ah
		db "Begonnen wird mit dem niedrigsten",0Dh,0Ah
		db "Schreibtempo entsprechend dem Quick-",0Dh,0Ah
		db "save-Kommando \iQV 32\i, beendet mit",0Dh,0Ah
		db "\i09\i.",0Dh,0Ah
		db "Im zweiten Teil des Testprogramms wird",0Dh,0Ah
		db "diese Aufzeichnung geprueft.",0Dh,0Ah
		db "Achten Sie auf nicht zu hohe Aussteu-",0Dh,0Ah
		db "erung!",0Dh,0Ah
		db "Start mit ENTER, Abbruch mit STOP.",0Dh,0Ah,0
		call	ENTER		; Warten auf ENTER
		ld	a, 32
		ld	(tempo), a
		sub	3
		call	qvalue1		; Tempo	setzen
		ld	c, 15		; OPENW
		call	5
		ret	c
		rst	8
		db "Geschwindigkeit: 32",0
		ld	a, 19		; 20-1
		jr	tt2
;
tt1:		rst	8
		db 8,8,0
		call	OUTNUM		; A als	Dezimalzahl anzeigen
		ld	a, (tempo)
		sub	3		; nn-3
		call	qvalue1		; Tempo	setzen
		ld	a, 20		; Blockzhler
tt2:		ld	hl, TT
		ld	(1Bh), hl	; DMA
		ld	hl, NumBlk	; Anzahl der noch zu schreibenden/lesenden Blcke
		ld	(hl), a
tt3:		ld	c, 21		; WRITS
		call	5
		call	consi		; Zeicheneingabe
		dec	(hl)		; NUMBLK
		jr	nz, tt3		; bis 20 Blcke	geschrieben
		call	wait		; kurze	Warteschleife
		call	schneller
		jr	nz, tt1
		call	CLS
		rst	8
		db "Jetzt spulen Sie bitte das Band zum",0Dh,0Ah
		db "Beginn der Aufzeichnung zurueck und",0Dh,0Ah
		db "schalten auf Wiedergabe. Das Programm",0Dh,0Ah
		db "prueft im folgenden die Aufzeichung und",0Dh,0Ah
		db "gibt bei jedem fehlerfrei gelesenen",0Dh,0Ah
		db "Block \i-\i aus, sonst \i+\i.",0Dh,0Ah
		db "Sie ersehen daran, welche Aufzeich-",0Dh,0Ah
		db "nungsgeschwindigkeit bzw. Aussteuerung",0Dh,0Ah
		db "des Kassettengeraets zulaessig ist.",0Dh,0Ah
		db "Wir empfehlen 2 Geschwindigkeitsstufen",0Dh,0Ah
		db "Reserve.",0Dh,0Ah
		db "Beim Startton ENTER druecken!",0Dh,0Ah,0
		call	ENTER		; Warten auf ENTER
		call	CLS
		ld	a, 32		; Anfangstempo
		ld	(tempo), a
		;
tt4:		rst	8
		db "Geschwindigkeit:",0
		call	OUTNUM		; A als	Dezimalzahl anzeigen
		ld	a, (tempo)
		sub	3
		call	qvalue1		; Tempo	setzen
		ld	hl, NumBlk	; Anzahl der noch zu schreibenden/lesenden Blcke
		ld	(hl), 20	; 20 Blcke ausgeben
		;
tt5:		exx
		ld	hl, ENDE
		ld	(1Bh), hl	; DMA
		call	0FF59h		; MAREK
		exx
		ld	a, '-'          ; '-' bei Lesefehler
		jr	nc, tt6
		ld	a, '+'
tt6:		call	0F305h
		call	consi		; Zeicheneingabe
		dec	(hl)
		jr	nz, tt5
		;
		rst	8
		db 0Dh,0Ah,0
		call	schneller
		jr	nz, tt4
		;
		rst	8
		db 0Ah
		db "   *** ende ***",0Dh,0Ah,0
		ld	c, 25		; INITA
		call	5
		jp	norm


; ---------------------------------------------------------------------------
; QUICKSAVE 

		include	QSW.asm



; ---------------------------------------------------------------------------
; Bildschirm rckwrts lschen
CLS:		ld	hl, 0EFBFh	; letzte BWS-Adresse
		ld	d, h
		ld	e, l
		dec	de
		ld	bc, 959
		lddr
		ld	c, 18		; SETCU
		ld	de, 101h
		jp	5

; ---------------------------------------------------------------------------
; A als	Dezimalzahl anzeigen
OUTNUM:		ld	bc, 0A02h	; B = 10, C = 2	CONSO
		call	OUTNUM1
		ld	b, 1
OUTNUM1:	ld	e, '0'-1
OUTNUM2:	sub	b
		inc	e
		jr	nc, OUTNUM2
		add	a, b
		jp	5

; ---------------------------------------------------------------------------
; Ausgabe Zeichenkette
RST8:		exx			
		ex	af, af'
		pop	de
		ld	c, 9		; PRNST
		call	5
		ex	de, hl
		xor	a		; A := 0
		ld	b, c
		cpir			; Ende der Zeichenkette suchen
		push	hl
		ex	af, af'
		exx
		ret

; ---------------------------------------------------------------------------
; Tempozhler vermindern
schneller:	ld	a, (tempo)
		dec	a
		cp	20
		jr	c, schneller1
		dec	a
schneller1:	ld	(tempo), a
		cp	8
		ret

; ---------------------------------------------------------------------------
; Warten auf ENTER
ENTER:
		call	consi		; Zeicheneingabe
		cp	0Dh
		ret	z
		jr	ENTER		; Warten auf ENTER

; ---------------------------------------------------------------------------
; Zeicheneingabe
consi:		ld	c, 11		; CSTS
		call	5
		or	a
		ret	z
		cp	3
		ret	nz
		jp	0

; ---------------------------------------------------------------------------
; kurze	Warteschleife
wait:		push	bc
		ld	b, 40
wait1:		dec	bc
		inc	b
		djnz	wait1
		pop	bc
		ret

; ---------------------------------------------------------------------------
tempo:		db 	0
NumBlk:		db    	0		; Anzahl der noch zu schreibenden/lesenden Bloecke
ENDE:		equ	$

		end
